package net.shambolica.helperl.pattern;

import com.ericsson.otp.erlang.OtpErlangObject;
import net.shambolica.helperl.conversion.FromObject;
import net.shambolica.helperl.pattern.instance.PEq;
import net.shambolica.helperl.pattern.instance.PSet;

/**
 * Matching operations for implementing {@link OEValueBinder}s.
 */
public class Matching {

    public static OEValueBinder[] toPatterns(Object ... objects) {
        if (objects == null) {

            return null;

        } else {

            OEValueBinder[] vbs = new OEValueBinder[objects.length];

            for (int i = 0 ; i < objects.length ; i++) {
                Object object = objects[i];
                vbs[i] = asPattern(object);
            }

            return vbs;

        }
    }

    public static OEValueBinder asPattern(Object object) {
        OEValueBinder vb;

        if (object == null) {
            vb = new PEq(FromObject.asObject(object));
        } else if (object instanceof OEValueBinder) {
            vb = (OEValueBinder) object;
        } else if (object instanceof String) {
            vb = new PSet((String) object);
        } else {
            vb = new PEq(FromObject.asObject(object));
        }
        return vb;
    }


    public static boolean match(OtpErlangObject target, MatchContext context, OEValueBinder[] patterns) {
        for (OEValueBinder pattern : patterns) {
            if (!pattern.bind(target, context)) {
                return false;
            }
        }
        return true;

    }

    public static boolean matchAll(OtpErlangObject[] targets, MatchContext matchContext, OEValueBinder[] patterns) {
        for (int i = 0 ; i < patterns.length ; i++) {
            if (! patterns[i].bind(targets[i], matchContext)) {
                return false;
            }
        }
        return true;
    }

}
