package net.shambolica.helperl.pattern;

import com.ericsson.otp.erlang.OtpErlangObject;

import java.util.Collections;
import java.util.Map;

/**
 * User-facing interface.
 */
public abstract class OEPattern {

    public boolean matches(OtpErlangObject target) {
        return match(target) != null;
    }

    public Map<String, OtpErlangObject> match(OtpErlangObject target) {
         if (target == null) {
             return Collections.emptyMap();
         } else {
             MatchContext context = new MatchContext();
             boolean matched = ((OEValueBinder)this).bind(target, context);
             if (matched) {
                 return context.getBindingMap();
             } else {
                 return null;
             }
         }
    }

}
