package net.shambolica.helperl.pattern.instance;

import com.ericsson.otp.erlang.OtpErlangObject;
import net.shambolica.helperl.pattern.CompositePattern;
import net.shambolica.helperl.pattern.MatchContext;
import net.shambolica.helperl.pattern.OEValueBinder;

/**
 * Short-circuit try until first match.
 */
public class POr extends CompositePattern {

    private final OEValueBinder[] patterns;


    public POr(OEValueBinder ... patterns) {
        if (patterns.length == 0) {
            throw new IllegalArgumentException("zero sub-patterns for POr");
        }

        this.patterns = patterns;
    }


    @Override
    public boolean bind(OtpErlangObject target, MatchContext context) {
        int rollback = context.getMark();
        for (OEValueBinder pattern : patterns) {
            if (pattern.bind(target, context)) {
                return true;
            } else {
                context.setMark(rollback);
            }
        }
        return false;
    }

}
