package net.shambolica.helperl.util;

public class Pair<A,B> {

    private final A a;
    private final B b;


    public static <A,B> Pair<A,B> pair(A a, B b) {
        return new Pair<A, B>(a, b);
    }


    public Pair(A a, B b) {
        this.a = a;
        this.b = b;
    }


    public A getA() {
        return a;
    }

    public B getB() {
        return b;
    }


    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (!(o instanceof Pair)) return false;

        Pair pair = (Pair) o;

        if (a != null ? !a.equals(pair.a) : pair.a != null) return false;
        if (b != null ? !b.equals(pair.b) : pair.b != null) return false;

        return true;
    }

    @Override
    public int hashCode() {
        int result = a != null ? a.hashCode() : 0;
        result = 31 * result + (b != null ? b.hashCode() : 0);
        return result;
    }

}
